﻿using System.Linq;
public class ConsoleScrollback : Mod
{
    private static System.Int32 scrollBackSize = (System.Int32)System.Int16.MaxValue;
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.console-scrollback";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
        //InvokeRepeating("Spam", 0f, 0.2f);
    }
    [HarmonyLib.HarmonyPatch(typeof(RConsole), "HandleUnityLog", new System.Type[] { typeof(string), typeof(string), typeof(UnityEngine.LogType) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.VeryHigh)]
    public class HarmonyPatch_RConsole_HandleUnityLog
    {
        private class PatchInstruction
        {
            public System.Reflection.Emit.OpCode opCode;
            public string operandString;
            public System.Reflection.Emit.OpCode? newOpCode = null;
            public object newOperand = null;
        }
        private static PatchInstruction[] patchInstructions = new PatchInstruction[]{
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldsfld, operandString = "System.Collections.Generic.List`1[UnityEngine.GameObject] logs" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "Int32 get_Count()" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_S, newOpCode = System.Reflection.Emit.OpCodes.Ldc_I4, newOperand = scrollBackSize },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Blt_S, operandString = "System.Reflection.Emit.Label", newOpCode = System.Reflection.Emit.OpCodes.Blt },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldsfld, operandString = "System.Collections.Generic.List`1[UnityEngine.GameObject] logs" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Call, operandString = "UnityEngine.GameObject First[GameObject](System.Collections.Generic.IEnumerable`1[UnityEngine.GameObject])" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Call, operandString = "Void Destroy(UnityEngine.Object)" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldsfld, operandString = "System.Collections.Generic.List`1[UnityEngine.GameObject] logs" },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Ldc_I4_0 },
            new PatchInstruction { opCode = System.Reflection.Emit.OpCodes.Callvirt, operandString = "Void RemoveAt(Int32)" },
        };
        static System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> Transpiler(System.Collections.Generic.IEnumerable<HarmonyLib.CodeInstruction> codeInstructionsEnumerable)
        {
            System.Collections.Generic.List<HarmonyLib.CodeInstruction> codeInstructions = new System.Collections.Generic.List<HarmonyLib.CodeInstruction>(codeInstructionsEnumerable);
            int? startPatch = null;
            int codeLength = codeInstructions.Count;
            int patchLength = patchInstructions.Length;
            for (int codeStart = 0; codeStart < codeLength; codeStart++)
            {
                if (codeStart + patchLength > codeLength)
                {
                    break;
                }
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = codeStart + patchCursor;
                    HarmonyLib.CodeInstruction codeInstruction = codeInstructions[codeCursor];
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (codeInstruction.opcode == patchInstruction.opCode && (patchInstruction.operandString == null || codeInstruction.operand?.ToString() == patchInstruction.operandString))
                    {
                        if (patchCursor == 0)
                        {
                            startPatch = codeStart;
                        }
                        if (patchCursor == patchLength - 1)
                        {
                            break;
                        }
                    }
                    else
                    {
                        startPatch = null;
                        break;
                    }
                }
                if (startPatch != null)
                {
                    break;
                }
            }
            if (startPatch != null)
            {
                for (int patchCursor = 0; patchCursor < patchLength; patchCursor++)
                {
                    int codeCursor = (int)startPatch + patchCursor;
                    PatchInstruction patchInstruction = patchInstructions[patchCursor];
                    if (patchInstruction.newOpCode != null)
                    {
                        codeInstructions[codeCursor].opcode = (System.Reflection.Emit.OpCode)patchInstruction.newOpCode;
                    }
                    if (patchInstruction.newOperand != null)
                    {
                        codeInstructions[codeCursor].operand = patchInstruction.newOperand;
                    }
                }
            }
            return codeInstructions.AsEnumerable();
        }
    }
    private static int spamCounter = 0;
    public void Spam()
    {
        if (spamCounter > scrollBackSize)
        {
            CancelInvoke();
            spamCounter = 0;
        }
        UnityEngine.Debug.Log("ConsoleScrollback spam #" + ++spamCounter);
    }
}
